# Libdevice functions

CUDA Built-in Target deprecation notice

The CUDA target built-in to Numba is deprecated, with further development moved to the NVIDIA numba-cuda package. Please see Built-in CUDA target deprecation and maintenance status.

All wrapped libdevice functions are listed in this section. All functions in libdevice are wrapped, with the exception of `__nv_nan` and `__nv_nanf`. These functions return a representation of a quiet NaN, but the argument they take (a pointer to an object specifying the representation) is undocumented, and follows an unusual form compared to the rest of libdevice - it is not an output like every other pointer argument. If a NaN is required, one can be obtained in CUDA Python by other means, e.g. `math.nan`.

## Wrapped functions

numba.cuda.libdevice.abs(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_abs.html

  Parameters:

    x (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.acos(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_acos.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.acosf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_acosf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.acosh(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_acosh.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.acoshf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_acoshf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.asin(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_asin.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.asinf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_asinf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.asinh(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_asinh.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.asinhf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_asinhf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.atan(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_atan.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.atan2(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_atan2.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.atan2f(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_atan2f.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.atanf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_atanf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.atanh(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_atanh.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.atanhf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_atanhf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.brev(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_brev.html

  Parameters:

    x (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.brevll(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_brevll.html

  Parameters:

    x (int64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.byte_perm(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_byte_perm.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

    - z (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.cbrt(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_cbrt.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.cbrtf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_cbrtf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ceil(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ceil.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ceilf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ceilf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.clz(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_clz.html

  Parameters:

    x (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.clzll(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_clzll.html

  Parameters:

    x (int64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.copysign(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_copysign.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.copysignf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_copysignf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.cos(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_cos.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.cosf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_cosf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.cosh(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_cosh.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.coshf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_coshf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.cospi(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_cospi.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.cospif(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_cospif.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.dadd_rd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dadd_rd.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dadd_rn(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dadd_rn.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dadd_ru(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dadd_ru.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dadd_rz(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dadd_rz.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ddiv_rd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ddiv_rd.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ddiv_rn(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ddiv_rn.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ddiv_ru(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ddiv_ru.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ddiv_rz(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ddiv_rz.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dmul_rd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dmul_rd.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dmul_rn(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dmul_rn.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dmul_ru(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dmul_ru.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dmul_rz(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dmul_rz.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.double2float_rd(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2float_rd.html

  Parameters:

    d (float64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.double2float_rn(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2float_rn.html

  Parameters:

    d (float64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.double2float_ru(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2float_ru.html

  Parameters:

    d (float64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.double2float_rz(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2float_rz.html

  Parameters:

    d (float64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.double2hiint(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2hiint.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2int_rd(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2int_rd.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2int_rn(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2int_rn.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2int_ru(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2int_ru.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2int_rz(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2int_rz.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2ll_rd(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2ll_rd.html

  Parameters:

    f (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.double2ll_rn(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2ll_rn.html

  Parameters:

    f (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.double2ll_ru(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2ll_ru.html

  Parameters:

    f (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.double2ll_rz(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2ll_rz.html

  Parameters:

    f (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.double2loint(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2loint.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2uint_rd(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2uint_rd.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2uint_rn(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2uint_rn.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2uint_ru(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2uint_ru.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2uint_rz(d)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2uint_rz.html

  Parameters:

    d (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.double2ull_rd(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2ull_rd.html

  Parameters:

    f (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.double2ull_rn(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2ull_rn.html

  Parameters:

    f (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.double2ull_ru(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2ull_ru.html

  Parameters:

    f (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.double2ull_rz(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double2ull_rz.html

  Parameters:

    f (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.double_as_longlong(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_double_as_longlong.html

  Parameters:

    x (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.drcp_rd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_drcp_rd.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.drcp_rn(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_drcp_rn.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.drcp_ru(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_drcp_ru.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.drcp_rz(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_drcp_rz.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dsqrt_rd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dsqrt_rd.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dsqrt_rn(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dsqrt_rn.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dsqrt_ru(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dsqrt_ru.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.dsqrt_rz(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_dsqrt_rz.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.erf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erf.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.erfc(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erfc.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.erfcf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erfcf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.erfcinv(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erfcinv.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.erfcinvf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erfcinvf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.erfcx(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erfcx.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.erfcxf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erfcxf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.erff(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erff.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.erfinv(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erfinv.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.erfinvf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_erfinvf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.exp(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_exp.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.exp10(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_exp10.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.exp10f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_exp10f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.exp2(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_exp2.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.exp2f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_exp2f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.expf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_expf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.expm1(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_expm1.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.expm1f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_expm1f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fabs(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fabs.html

  Parameters:

    f (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fabsf(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fabsf.html

  Parameters:

    f (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fadd_rd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fadd_rd.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fadd_rn(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fadd_rn.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fadd_ru(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fadd_ru.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fadd_rz(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fadd_rz.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_cosf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_cosf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_exp10f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_exp10f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_expf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_expf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_fdividef(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_fdividef.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_log10f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_log10f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_log2f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_log2f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_logf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_logf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_powf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_powf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_sincosf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_sincosf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    UniTuple(float32 x 2)

numba.cuda.libdevice.fast_sinf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_sinf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fast_tanf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fast_tanf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fdim(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fdim.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fdimf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fdimf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fdiv_rd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fdiv_rd.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fdiv_rn(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fdiv_rn.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fdiv_ru(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fdiv_ru.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fdiv_rz(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fdiv_rz.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ffs(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ffs.html

  Parameters:

    x (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.ffsll(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ffsll.html

  Parameters:

    x (int64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.finitef(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_finitef.html

  Parameters:

    x (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.float2half_rn(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2half_rn.html

  Parameters:

    f (float32) – Argument.

  Return type:

    int16

numba.cuda.libdevice.float2int_rd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2int_rd.html

  Parameters:

    in (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.float2int_rn(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2int_rn.html

  Parameters:

    in (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.float2int_ru(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2int_ru.html

  Parameters:

    in (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.float2int_rz(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2int_rz.html

  Parameters:

    in (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.float2ll_rd(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2ll_rd.html

  Parameters:

    f (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.float2ll_rn(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2ll_rn.html

  Parameters:

    f (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.float2ll_ru(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2ll_ru.html

  Parameters:

    f (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.float2ll_rz(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2ll_rz.html

  Parameters:

    f (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.float2uint_rd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2uint_rd.html

  Parameters:

    in (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.float2uint_rn(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2uint_rn.html

  Parameters:

    in (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.float2uint_ru(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2uint_ru.html

  Parameters:

    in (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.float2uint_rz(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2uint_rz.html

  Parameters:

    in (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.float2ull_rd(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2ull_rd.html

  Parameters:

    f (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.float2ull_rn(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2ull_rn.html

  Parameters:

    f (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.float2ull_ru(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2ull_ru.html

  Parameters:

    f (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.float2ull_rz(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float2ull_rz.html

  Parameters:

    f (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.float_as_int(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_float_as_int.html

  Parameters:

    x (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.floor(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_floor.html

  Parameters:

    f (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.floorf(f)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_floorf.html

  Parameters:

    f (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fma(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fma.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

    - z (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fma_rd(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fma_rd.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

    - z (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fma_rn(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fma_rn.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

    - z (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fma_ru(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fma_ru.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

    - z (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fma_rz(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fma_rz.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

    - z (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fmaf(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmaf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

    - z (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmaf_rd(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmaf_rd.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

    - z (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmaf_rn(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmaf_rn.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

    - z (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmaf_ru(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmaf_ru.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

    - z (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmaf_rz(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmaf_rz.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

    - z (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmax(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmax.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fmaxf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmaxf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmin(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmin.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fminf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fminf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmod(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmod.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.fmodf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmodf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmul_rd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmul_rd.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmul_rn(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmul_rn.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmul_ru(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmul_ru.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fmul_rz(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fmul_rz.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.frcp_rd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_frcp_rd.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.frcp_rn(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_frcp_rn.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.frcp_ru(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_frcp_ru.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.frcp_rz(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_frcp_rz.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.frexp(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_frexp.html

  Parameters:

    x (float64) – Argument.

  Return type:

    Tuple(float64, int32)

numba.cuda.libdevice.frexpf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_frexpf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    Tuple(float32, int32)

numba.cuda.libdevice.frsqrt_rn(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_frsqrt_rn.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fsqrt_rd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fsqrt_rd.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fsqrt_rn(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fsqrt_rn.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fsqrt_ru(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fsqrt_ru.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fsqrt_rz(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fsqrt_rz.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fsub_rd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fsub_rd.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fsub_rn(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fsub_rn.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fsub_ru(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fsub_ru.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.fsub_rz(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_fsub_rz.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.hadd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_hadd.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.half2float(h)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_half2float.html

  Parameters:

    h (int16) – Argument.

  Return type:

    float32

numba.cuda.libdevice.hiloint2double(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_hiloint2double.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    float64

numba.cuda.libdevice.hypot(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_hypot.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.hypotf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_hypotf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ilogb(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ilogb.html

  Parameters:

    x (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.ilogbf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ilogbf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.int2double_rn(i)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_int2double_rn.html

  Parameters:

    i (int32) – Argument.

  Return type:

    float64

numba.cuda.libdevice.int2float_rd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_int2float_rd.html

  Parameters:

    in (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.int2float_rn(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_int2float_rn.html

  Parameters:

    in (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.int2float_ru(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_int2float_ru.html

  Parameters:

    in (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.int2float_rz(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_int2float_rz.html

  Parameters:

    in (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.int_as_float(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_int_as_float.html

  Parameters:

    x (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.isfinited(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_isfinited.html

  Parameters:

    x (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.isinfd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_isinfd.html

  Parameters:

    x (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.isinff(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_isinff.html

  Parameters:

    x (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.isnand(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_isnand.html

  Parameters:

    x (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.isnanf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_isnanf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.j0(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_j0.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.j0f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_j0f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.j1(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_j1.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.j1f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_j1f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.jn(n, x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_jn.html

  Parameters:

    - n (int32) – Argument.

    - x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.jnf(n, x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_jnf.html

  Parameters:

    - n (int32) – Argument.

    - x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ldexp(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ldexp.html

  Parameters:

    - x (float64) – Argument.

    - y (int32) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ldexpf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ldexpf.html

  Parameters:

    - x (float32) – Argument.

    - y (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.lgamma(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_lgamma.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.lgammaf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_lgammaf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ll2double_rd(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ll2double_rd.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ll2double_rn(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ll2double_rn.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ll2double_ru(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ll2double_ru.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ll2double_rz(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ll2double_rz.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ll2float_rd(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ll2float_rd.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ll2float_rn(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ll2float_rn.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ll2float_ru(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ll2float_ru.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ll2float_rz(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ll2float_rz.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.llabs(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_llabs.html

  Parameters:

    x (int64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.llmax(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_llmax.html

  Parameters:

    - x (int64) – Argument.

    - y (int64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.llmin(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_llmin.html

  Parameters:

    - x (int64) – Argument.

    - y (int64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.llrint(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_llrint.html

  Parameters:

    x (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.llrintf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_llrintf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.llround(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_llround.html

  Parameters:

    x (float64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.llroundf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_llroundf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    int64

numba.cuda.libdevice.log(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_log.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.log10(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_log10.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.log10f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_log10f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.log1p(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_log1p.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.log1pf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_log1pf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.log2(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_log2.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.log2f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_log2f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.logb(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_logb.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.logbf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_logbf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.logf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_logf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.longlong_as_double(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_longlong_as_double.html

  Parameters:

    x (int64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.max(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_max.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.min(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_min.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.modf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_modf.html

  Parameters:

    x (float64) – Argument.

  Return type:

    UniTuple(float64 x 2)

numba.cuda.libdevice.modff(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_modff.html

  Parameters:

    x (float32) – Argument.

  Return type:

    UniTuple(float32 x 2)

numba.cuda.libdevice.mul24(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_mul24.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.mul64hi(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_mul64hi.html

  Parameters:

    - x (int64) – Argument.

    - y (int64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.mulhi(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_mulhi.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.nearbyint(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_nearbyint.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.nearbyintf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_nearbyintf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.nextafter(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_nextafter.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.nextafterf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_nextafterf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.normcdf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_normcdf.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.normcdff(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_normcdff.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.normcdfinv(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_normcdfinv.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.normcdfinvf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_normcdfinvf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.popc(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_popc.html

  Parameters:

    x (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.popcll(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_popcll.html

  Parameters:

    x (int64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.pow(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_pow.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.powf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_powf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.powi(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_powi.html

  Parameters:

    - x (float64) – Argument.

    - y (int32) – Argument.

  Return type:

    float64

numba.cuda.libdevice.powif(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_powif.html

  Parameters:

    - x (float32) – Argument.

    - y (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.rcbrt(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_rcbrt.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.rcbrtf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_rcbrtf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.remainder(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_remainder.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.remainderf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_remainderf.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.remquo(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_remquo.html

  Parameters:

    - x (float64) – Argument.

    - y (float64) – Argument.

  Return type:

    Tuple(float64, int32)

numba.cuda.libdevice.remquof(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_remquof.html

  Parameters:

    - x (float32) – Argument.

    - y (float32) – Argument.

  Return type:

    Tuple(float32, int32)

numba.cuda.libdevice.rhadd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_rhadd.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.rint(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_rint.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.rintf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_rintf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.round(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_round.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.roundf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_roundf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.rsqrt(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_rsqrt.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.rsqrtf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_rsqrtf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.sad(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sad.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

    - z (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.saturatef(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_saturatef.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.scalbn(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_scalbn.html

  Parameters:

    - x (float64) – Argument.

    - y (int32) – Argument.

  Return type:

    float64

numba.cuda.libdevice.scalbnf(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_scalbnf.html

  Parameters:

    - x (float32) – Argument.

    - y (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.signbitd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_signbitd.html

  Parameters:

    x (float64) – Argument.

  Return type:

    int32

numba.cuda.libdevice.signbitf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_signbitf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.sin(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sin.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.sincos(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sincos.html

  Parameters:

    x (float64) – Argument.

  Return type:

    UniTuple(float64 x 2)

numba.cuda.libdevice.sincosf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sincosf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    UniTuple(float32 x 2)

numba.cuda.libdevice.sincospi(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sincospi.html

  Parameters:

    x (float64) – Argument.

  Return type:

    UniTuple(float64 x 2)

numba.cuda.libdevice.sincospif(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sincospif.html

  Parameters:

    x (float32) – Argument.

  Return type:

    UniTuple(float32 x 2)

numba.cuda.libdevice.sinf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sinf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.sinh(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sinh.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.sinhf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sinhf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.sinpi(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sinpi.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.sinpif(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sinpif.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.sqrt(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sqrt.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.sqrtf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_sqrtf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.tan(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_tan.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.tanf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_tanf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.tanh(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_tanh.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.tanhf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_tanhf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.tgamma(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_tgamma.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.tgammaf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_tgammaf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.trunc(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_trunc.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.truncf(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_truncf.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.uhadd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_uhadd.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.uint2double_rn(i)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_uint2double_rn.html

  Parameters:

    i (int32) – Argument.

  Return type:

    float64

numba.cuda.libdevice.uint2float_rd(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_uint2float_rd.html

  Parameters:

    in (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.uint2float_rn(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_uint2float_rn.html

  Parameters:

    in (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.uint2float_ru(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_uint2float_ru.html

  Parameters:

    in (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.uint2float_rz(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_uint2float_rz.html

  Parameters:

    in (int32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ull2double_rd(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ull2double_rd.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ull2double_rn(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ull2double_rn.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ull2double_ru(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ull2double_ru.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ull2double_rz(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ull2double_rz.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ull2float_rd(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ull2float_rd.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ull2float_rn(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ull2float_rn.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ull2float_ru(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ull2float_ru.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ull2float_rz(l)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ull2float_rz.html

  Parameters:

    l (int64) – Argument.

  Return type:

    float32

numba.cuda.libdevice.ullmax(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ullmax.html

  Parameters:

    - x (int64) – Argument.

    - y (int64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.ullmin(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ullmin.html

  Parameters:

    - x (int64) – Argument.

    - y (int64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.umax(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_umax.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.umin(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_umin.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.umul24(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_umul24.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.umul64hi(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_umul64hi.html

  Parameters:

    - x (int64) – Argument.

    - y (int64) – Argument.

  Return type:

    int64

numba.cuda.libdevice.umulhi(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_umulhi.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.urhadd(x, y)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_urhadd.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.usad(x, y, z)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_usad.html

  Parameters:

    - x (int32) – Argument.

    - y (int32) – Argument.

    - z (int32) – Argument.

  Return type:

    int32

numba.cuda.libdevice.y0(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_y0.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.y0f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_y0f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.y1(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_y1.html

  Parameters:

    x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.y1f(x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_y1f.html

  Parameters:

    x (float32) – Argument.

  Return type:

    float32

numba.cuda.libdevice.yn(n, x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_yn.html

  Parameters:

    - n (int32) – Argument.

    - x (float64) – Argument.

  Return type:

    float64

numba.cuda.libdevice.ynf(n, x)

  See https://docs.nvidia.com/cuda/libdevice-users-guide/__nv_ynf.html

  Parameters:

    - n (int32) – Argument.

    - x (float32) – Argument.

  Return type:

    float32